mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.Object System.Collections.IDictionary System.Runtime.InteropServices.ComVisible(true)

The foreach statement of the C# language (for each in Visual Basic) requires the type of each element in the collection. Since each element of the is a key/value pair, the element type is not the type of the key or the type of the value. Instead, the element type is .

The foreach statement is a wrapper around the enumerator, which only allows reading from, not writing to, the collection.

Because keys can be inherited and their behavior changed, their absolute uniqueness cannot be guaranteed by comparisons using the method.

Provides the abstract base class for a strongly typed collection of key/value pairs.

- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  This constructor is an O(1) operation.

  Initializes a new instance of the class.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void

  is set to zero, and references to other objects from elements of the collection are also released.

  This method is an O() operation, where is .

  Clears the contents of the instance.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The elements are copied to the in the same order in which the enumerator iterates through the .

  This method is an O() operation, where is .

  Copies the elements to a one-dimensional at the specified index.

  The one-dimensional that is the destination of the objects copied from the instance. The must have zero-based indexing. The zero-based index in at which copying begins.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Int32 To be added: an object of type 'int'

  Retrieving the value of this property is an O(1) operation.

  Gets the number of elements contained in the instance.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.IDictionary To be added: an object of type 'IDictionary'

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  Retrieving the value of this property is an O(1) operation.

  Gets the list of elements contained in the instance.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.IDictionaryEnumerator

  The foreach statement of the C# language (for each in Visual Basic) hides the complexity of the enumerators. Therefore, using foreach is recommended, instead of directly manipulating the enumerator.

  Enumerators can be used to read the data in the collection, but they cannot be used to modify the underlying collection.

  Initially, the enumerator is positioned before the first element in the collection. also brings the enumerator back to this position. At this position, is undefined. Therefore, you must call to advance the enumerator to the first element of the collection before reading the value of .

  returns the same object until either or is called. sets to the next element.

  If passes the end of the collection, the enumerator is positioned after the last element in the collection and returns false. When the enumerator is at this position, subsequent calls to also return false. If the last call to returned false, is undefined. To set to the first element of the collection again, you can call followed by .

  An enumerator remains valid as long as the collection remains unchanged. If changes are made to the collection, such as adding, modifying, or deleting elements, the enumerator is irrecoverably invalidated and its behavior is undefined.

  The enumerator does not have exclusive access to the collection; therefore, enumerating through a collection is intrinsically not a thread-safe procedure. To guarantee thread safety during enumeration, you can lock the collection during the entire enumeration. To allow the collection to be accessed by multiple threads for reading and writing, you must implement your own synchronization.

  This method is an O(1) operation.

  Returns an that iterates through the instance.

  An for the instance.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.Hashtable To be added: an object of type 'Hashtable'

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  Retrieving the value of this property is an O(1) operation.

  Gets the list of elements contained in the instance.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void

  The default implementation of this method is intended to be overridden by a derived class to perform some action before the collection is cleared.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes before clearing the contents of the instance.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void

  The default implementation of this method is intended to be overridden by a derived class to perform some action after the collection is cleared.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes after clearing the contents of the instance.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Object `` ``

  The default implementation of this method returns . It is intended to be overridden by a derived class to perform additional action when the specified element is retrieved.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Gets the element with the specified key and value in the instance.

  An containing the element with the specified key and value.

  The key of the element to get. The current value of the element associated with .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action before the specified element is inserted.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes before inserting a new element into the instance.

  The key of the element to insert. The value of the element to insert.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action after the specified element is inserted.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes after inserting a new element into the instance.

  The key of the element to insert. The value of the element to insert.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action before the specified element is removed.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes before removing an element from the instance.

  The key of the element to remove. The value of the element to remove.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action after the specified element is removed.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes after removing an element from the instance.

  The key of the element to remove. The value of the element to remove.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action before the specified element is set.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes before setting a value in the instance.

  The key of the element to locate. The old value of the element associated with . The new value of the element associated with .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action after the specified element is set.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes after setting a value in the instance.

  The key of the element to locate. The old value of the element associated with . The new value of the element associated with .
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  The default implementation of this method is intended to be overridden by a derived class to perform some action when the specified element is validated.

  The On* methods are invoked only on the instance returned by the property, but not on the instance returned by the property.

  The default implementation of this method is an O(1) operation.

  Performs additional custom processes when validating the element with the specified key and value.

  The key of the element to validate. The value of the element to validate.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Boolean To be added.

  A object is not synchronized. Derived classes can provide a synchronized version of the class using the property.

  Enumerating through a collection is intrinsically not a thread-safe procedure. Even when a collection is synchronized, other threads can still modify the collection, which causes the enumerator to throw an exception. To guarantee thread safety during enumeration, you can either lock the collection during the entire enumeration or catch the exceptions resulting from changes made by other threads.

  Gets a value indicating whether access to a object is synchronized (thread safe).

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Object To be added.

  Derived classes can provide their own synchronized version of the class using the property. The synchronizing code must perform operations on the property of the object, not directly on the object. This ensures proper operation of collections that are derived from other objects. Specifically, it maintains proper synchronization with other threads that might be simultaneously modifying the object.

  Enumerating through a collection is intrinsically not a thread-safe procedure. Even when a collection is synchronized, other threads can still modify the collection, which causes the enumerator to throw an exception. To guarantee thread safety during enumeration, you can either lock the collection during the entire enumeration or catch the exceptions resulting from changes made by other threads.

  Gets an object that can be used to synchronize access to a object.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void `` ``

  An object that has no correlation between its state and its hash code value should typically not be used as the key. For example, objects are better than objects for use as keys.

  You can also use the property to add new elements by setting the value of a key that does not exist in the ; for example, myCollection["myNonexistentKey"] = myValue. However, if the specified key already exists in the , setting the property overwrites the old value. In contrast, the method does not modify existing elements.

  This method is an O(1) operation.

  Adds an element with the specified key and value into the .

  The key of the element to add. The value of the element to add.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Boolean ``

  This method is an O(1) operation.

  Starting with the .NET Framework 2.0, this method uses the collection’s objects’ and methods on to determine whether exists. In the earlier versions of the .NET Framework, this determination was made by using the and methods of the parameter on the objects in the collection.

  Determines whether the contains a specific key.

  true if the contains an element with the specified key; otherwise, false.

  The key to locate in the .
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Boolean To be added.

  A collection with a fixed size does not allow the addition or removal of elements after the collection is created, but does allow the modification of existing elements.

  A collection with a fixed size is simply a collection with a wrapper that prevents adding and removing elements; therefore, if changes are made to the underlying collection, including the addition or removal of elements, the fixed-size collection reflects those changes.

  Retrieving the value of this property is an O(1) operation.

  Gets a value indicating whether a object has a fixed size.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Boolean To be added.

  A collection that is read-only does not allow the addition, removal, or modification of elements after the collection is created.

  A collection that is read-only is simply a collection with a wrapper that prevents modifying the collection; therefore, if changes are made to the underlying collection, the read-only collection reflects those changes.

  Retrieving the value of this property is an O(1) operation.

  Gets a value indicating whether a object is read-only.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Object `` To be added. To be added. To be added. To be added.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.ICollection To be added.

  The order of the keys in the object is unspecified, but is the same order as the associated values in the object returned by the property.

  The returned is not a static copy; instead, the refers back to the keys in the original object. Therefore, changes to the continue to be reflected in the returned .

  Retrieving the value of this property is an O(1) operation.

  Gets an object containing the keys in the object.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void ``

  If the does not contain an element with the specified key, the remains unchanged. No exception is thrown.

  This method is an O(1) operation.

  Removes the element with the specified key from the .

  The key of the element to remove.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.ICollection To be added.

  The order of the values in the object is unspecified, but is the same order as the associated keys in the object returned by the property.

  The returned is not a static copy; instead, the refers back to the values in the original object. Therefore, changes to the continue to be reflected in the returned .

  Retrieving the value of this property is an O(1) operation.

  Gets an object containing the values in the object.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Collections.IEnumerator

  The foreach statement of the C# language (for each in Visual Basic) hides the complexity of the enumerators. Therefore, using foreach is recommended, instead of directly manipulating the enumerator.

  Enumerators can be used to read the data in the collection, but they cannot be used to modify the underlying collection.

  Initially, the enumerator is positioned before the first element in the collection. also brings the enumerator back to this position. At this position, calling throws an exception. Therefore, you must call to advance the enumerator to the first element of the collection before reading the value of .

  returns the same object until either or is called. sets to the next element.

  If passes the end of the collection, the enumerator is positioned after the last element in the collection and returns false. When the enumerator is at this position, subsequent calls to also return false. If the last call to returned false, calling throws an exception. To set to the first element of the collection again, you can call followed by .

  An enumerator remains valid as long as the collection remains unchanged. If changes are made to the collection, such as adding, modifying, or deleting elements, the enumerator is irrecoverably invalidated and the next call to or throws an . If the collection is modified between and , returns the element that it is set to, even if the enumerator is already invalidated.

  The enumerator does not have exclusive access to the collection; therefore, enumerating through a collection is intrinsically not a thread-safe procedure. Even when a collection is synchronized, other threads can still modify the collection, which causes the enumerator to throw an exception. To guarantee thread safety during enumeration, you can either lock the collection during the entire enumeration or catch the exceptions resulting from changes made by other threads.

  This method is an O(1) operation.

  Returns an that iterates through the .

  An for the .